// this function verifies disk space in kilobytes
function verifyDiskSpace(dirPath, spaceRequired)
{
  var spaceAvailable;

  // Get the available disk space on the given path
  spaceAvailable = fileGetDiskSpaceAvailable(dirPath);

  // Convert the available disk space into kilobytes
  spaceAvailable = parseInt(spaceAvailable / 1024);

  // do the verification
  if(spaceAvailable < spaceRequired)
  {
    logComment("Insufficient disk space: " + dirPath);
    logComment("  required : " + spaceRequired + " K");
    logComment("  available: " + spaceAvailable + " K");
    return(false);
  }

  return(true);
}
// main
var srDest;
var err;
var fProgram;
var fSearchPlugins; // searchplugins directory variable (mal@mozilla.gr.jp)

// OS type detection
// which platform?
// copy from install.js at langenus.xpi (mal@mozilla.gr.jp)
var platformStr = new String(Install.platform);
var platformNode;
if (!platformStr.search(/^Macintosh/))
    platformNode = 'mac';
else if (!platformStr.search(/^Win/))
    platformNode = 'win';
else
    platformNode = 'unix';

logComment("initInstall: platformNode=" + platformNode);
// end
// end - OS type detection

// ----LOCALIZATION NOTE: translate only these ------
var prettyName = "JP Region Pack";
var chromeNode = "JP";
// --- END CHANGABLE STUFF ---

var regName    = "locales/mozilla/" + chromeNode;
var chromeName = chromeNode + ".jar";
var localeName = "locale/" + chromeNode + "/";

srDest = 769;
err    = initInstall(prettyName, regName, "5.0.0.2001101117"); 
logComment("initInstall: " + err);

fProgram = getFolder("Program");
logComment("fProgram: " + fProgram);

// searchplugins directory detection (mal@mozilla.gr.jp)
if(platformNode == 'mac')
{
  fSearchPlugins = getFolder("Program", "Search Plugins");
} else {
  fSearchPlugins = getFolder("Program", "searchplugins");
}
logComment("fSearchPlugins: " + fSearchPlugins);

if(verifyDiskSpace(fProgram, srDest))
{
  setPackageFolder(fProgram);
  err = addDirectory("",
                     "5.0.0.2001101117",
                     "bin",              // dir name in jar to extract 
                     fProgram,           // Where to put this file (Returned from GetFolder) 
                     "",                 // subdir name to create relative to fProgram
                     true);              // Force Flag 
  logComment("addDirectory() returned: " + err);

  // register chrome
  var cf = getFolder("Chrome");
  registerChrome(LOCALE | DELAYED_CHROME, getFolder(cf, chromeName), localeName + "global-region/");
  registerChrome(LOCALE | DELAYED_CHROME, getFolder(cf, chromeName), localeName + "communicator-region/");
  registerChrome(LOCALE | DELAYED_CHROME, getFolder(cf, chromeName), localeName + "editor-region/");
  registerChrome(LOCALE | DELAYED_CHROME, getFolder(cf, chromeName), localeName + "messenger-region/");
  registerChrome(LOCALE | DELAYED_CHROME, getFolder(cf, chromeName), localeName + "navigator-region/");

}
else
  cancelInstall(INSUFFICIENT_DISK_SPACE);

// searchplugin install (mal@mozilla.gr.jp)
if(verifyDiskSpace(fSearchPlugins, srDest))
{
  err = addDirectory("", "sp", fSearchPlugins, "");
  logComment("addDirectory() searchplugins returned: " + err);

  if(platformNode != 'mac')
  {
    err = addDirectory("", "sp_nomac", fSearchPlugins, "");
    logComment("addDirectory() else mac searchplugins returned: " + err);
  }
}
else
  cancelInstall(INSUFFICIENT_DISK_SPACE);

// check return value (modified by mal@mozilla.gr.jp)
if(err == SUCCESS)
{
  err = performInstall(); 
  logComment("performInstall() returned: " + err);
}
else
  cancelInstall(err);

// end main
